/*
Copyright (c) 1997-2000, KeeBoo Corporation. 
Copyright application on progress at the Copyright Office.
All rights reserved.
This source code is the property of KeeBoo Corporation,
it cannot be reused, modified or published without prior 
written consent from KeeBoo Corporation.
KeeBoo and the KeeBoo logo are trademarks or registered
trademarks of KeeBoo Corporation.
*/

var _keeStickers=new Array
var _curSticker=-1
var _startX,_startY

function KeeBooStickerSty(id,color,x,y,w,h)
{
	var pos="z-index:2000;position:absolute;left:"+x+"px;top:"+y+"px;width:"+w+"px;height:"+h+"px;"
	var pos2="z-index:2000;position:absolute;left:"+x+"px;top:"+y+"px;width:"+Math.max(0,w-4)+"px;height:"+h+"px;"
	var alpha=(_ie||_moz)?"filter:alpha(opacity=85);":""
	var clip="clip:rect(0px,"+w+"px,"+h+"px,0px);"
	var bg=((_ns&&!_moz)?"layer-background-color":"background-color")+":"+color+";"
	var border=(_macIE&&_ie4)?"":"border-width:1px;border-color:black;border-style:solid;"
	var s=""
	
	s+="#keestickbg"+id+"{"+pos+alpha+bg+border+"}"
	s+="#keesticktxt"+id+"{"+pos2+clip+"padding:5px;font-family:'Verdana','Arial';font-size:13px;font-weight:bold;}"
	s+="#keestickfrm"+id+"{"+pos+"cursor:move}"
	return s
}

function getSticker(nx,ny)
{
	for (var i=_keeStickers.length-1;i>=0;i--) with (_keeStickers[i])
		if ((nx>=x)&&(nx<=(x+w))&&(ny>=y)&&(ny<=(y+h))) return i
	return -1
}

var _styZ=2000

function mouseDownCB(ev)
{
	if (_curSticker==-1)
	{
		_startX=eventGetX(ev)
		_startY=eventGetY(ev)
		_curSticker=getSticker(_startX,_startY)
		
		if (_curSticker>=0)
		{
			var last=_keeStickers.length-1
			var old=_keeStickers[_curSticker]
			_keeStickers[_curSticker]=_keeStickers[last]
			_keeStickers[last]=old
			_curSticker=last
		
			var id=_keeStickers[_curSticker].id
			if (_ie) layerCSS("keestickbg"+id).filter=''
			_styZ++
			layerCSS("keestickbg"+id).zIndex=_styZ
			layerCSS("keesticktxt"+id).zIndex=_styZ
			layerCSS("keestickfrm"+id).zIndex=_styZ
		}
	}
	return false
}

function mouseUpCB(ev)
{
	if (_curSticker>=0)
	{
		var stick=_keeStickers[_curSticker]
		stick.x=stick.x+eventGetX(ev)-_startX
		stick.y=stick.y+eventGetY(ev)-_startY
		_curSticker=-1
		if (_ie) layerCSS("keestickbg"+stick.id).filter='alpha(opacity=85)'
		return false
	}
	else return true
}

function mouseMoveCB(ev)
{
	if (_curSticker>=0)
	{
		var stick=_keeStickers[_curSticker]
		var x=stick.x+eventGetX(ev)-_startX
		var y=stick.y+eventGetY(ev)-_startY
		
		moveLayer(layerCSS("keestickbg"+stick.id),x,y)
		moveLayer(layerCSS("keesticktxt"+stick.id),x,y)
		moveLayer(layerCSS("keestickfrm"+stick.id),x,y)
		
		return false
	}
}

function initStickers()
{
	document.onmousedown=mouseDownCB
	document.onmouseup=mouseUpCB
	document.onmousemove=mouseMoveCB

	if (_ns) document.captureEvents(Event.MOUSEDOWN|Event.MOUSEMOVE|Event.MOUSEUP)
}

function stickerFrame(id,w,h)
{
	if (_ns) return "<DIV id='"+id+"'>"+box(w,h)+"</DIV>"
	else return "<TABLE ondragstart='return false' cellpadding=0 border=0 id='"+id+"'><TR><TD>"+box(w,h)+"</TD></TR></TABLE>"
}

function KeeBooSticker(id,str,x,y,w,h)
{
	var s=stickerFrame("keestickbg"+id,w,h,"")
	s+="<DIV id='keesticktxt"+id+"'>"+str+"</DIV>"	
	s+=stickerFrame("keestickfrm"+id,w,h)
	document.write(s)
	document.close()
	
	var info=new Array
	
	info["id"]=id
	info["x"]=x
	info["y"]=y
	info["w"]=w
	info["h"]=h
	_keeStickers[_keeStickers.length]=info
}
