/*
Copyright (c) 1997-2000,KeeBoo Corporation. All rights reserved.
Copyright application on progress at the Copyright Office.
This source code is the property of KeeBoo Corporation,
it cannot be reused,modified or published without prior 
written consent from KeeBoo Corporation.
KeeBoo and the KeeBoo logo are trademarks or registered
trademarks of KeeBoo Corporation.
*/

var _partner=_NULL
var _preload=false
var _keep=true
var _mode=0
var _dyn=false
var _engineVersion='2.2'
var _docVersion='2.2'
var _docVersionLabel='2.2'
var _isWebKeeBook = true
var _neu=''
var _localized=''
var _contents=''
var _root=''
var _common=''
var _audience=false
var _langName=''
var _lookName=''
var _searchWord=''
var _found=new Array()
var _Book=new Book
var _MAX_CHAPTER=11
var _keebooTopFrameset='here'
var _theWins
var _closePopups=true
var _findInTitles=true
var _findInPages=true
var _expand=false

var _page=new Array
_page["left"]=new PageInfo
_page["right"]=new PageInfo

function setDocVersion(version,versionLabel)
{
	_docVersion=version
	_docVersionLabel=versionLabel
}

function PageInfo()
{
	this.idx=0
	this.url=''
	this.title=''
	this.timer=_NULL
	this.external=false
	this.light=false
	this.navigate=false
}

function putInfoCB()
{
	setCookie('book_'+WebBookID,_Book.page+'"'+_Book.mode,30)
	if (_closePopups&&!_macIE) for (var i in _theWins) if (!_theWins[i].closed) _theWins[i].close()
}

function decodeParam(str)
{
	var p=new Array
	if (str!=_NULL)
	{
		if ((str.length>0)&&(str.charAt(0)=="?")) str=str.slice(1)
		var split1=str.split("&")
		for (var i in split1)
		{
			split2=split1[i].split("=")
			if (split2.length==2) p[split2[0]]=split2[1]
		}
	}
	return p
}

function Book_init(common,look,lang,contents,audience,langName,lookName,partner)
{
	_root=getPath(document)
	_common=calPath(_root,common)
	_localized=calPath(_root,lang)
	_neu=calPath(_root,look)
	_contents=calPath(_root,contents)
	_audience=audience==_NULL ? false : audience
	_langName=langName
	_lookName=lookName
	_partner=partner

	with(book)
	{
		if (!(_partner&&_dyn))
		{
			advertPage=new _KB_Page(_NULL,_NULL,_NULL,'advert',false)
			chapter.addItem(book,advertPage)
		}
		chapter.addItem(book,new _KB_Page(_NULL,_NULL,_NULL,'biblio',false))
		if (indexPage==_NULL) indexPage=new _KB_Page(_NULL,_NULL,_NULL,'index',false)
		chapter.addItem(book,indexPage)
	}
	
	var p=decodeParam(getCookie("DynKeeBookParam"))

	with (book)
	{
		if (params.page&&!params.page.force) _keep=params.page.val=="last"
		if (params.mode&&!params.mode.force) _mode=params.mode.val
	}

	if (p.preload!=_NULL) _preload=p.preload=="1"
	if (p.keep!=_NULL) _keep=p.keep=="1"
	if (p.mode!=_NULL) _mode=parseInt(p.mode)
	if (p.expand!=_NULL) _expand=p.expand=="1"

	with (book)
	{
		if (params.page&&params.page.force) _keep=params.page.val=="last"
		if (params.mode&&params.mode.force) _mode=params.mode.val
	}


	var pageCookie=_NULL
	var modeCookie=_NULL
	var theCookie= getCookie('book_'+WebBookID)
	if (theCookie!=_NULL)
	{
		var cookieTab=theCookie.split('"')
		if (cookieTab.length>=2)
		{
			if (_keep) pageCookie=cookieTab[0]
			if(_mode==0) modeCookie=cookieTab[1]
		}
	}

	var searchParam=decodeParam(location.search)
	this.mode=searchParam.mode
	this.page=searchParam.page

	if (this.mode==_NULL)
	{
		if (modeCookie!=_NULL) this.mode=parseInt(modeCookie)
		else
		{
			if (_mode==0) this.mode=2
			else this.mode=_mode
		}
	}
	else
	{
		this.mode=parseInt(this.mode)
		_preload=false
	}

	if (this.page==_NULL)
	{
		if (pageCookie!=_NULL) this.page=Math.min(book.pages.length-this.mode,parseInt(pageCookie))
		else
			this.page=this.mode==2?0:1
	}
	else this.page=parseInt(this.page)

	if ((_partner!=_NULL)&&(!_dyn))
	{
		_lab['limitText']=formatString(limit1Partner,_partner)+limit2+formatString(limit3Partner,_partner)
		_lab['authorDisclamer']=disc1+formatString(disc2Partner,_partner)+disc3
	}

	with (book.branding)
	{
		logoPath=calPath(_contents,logoPath,false)
		indexPath=calPath(_contents,indexPath,false)
		if (tocPath&&(tocPath!="")) tocPath=calPath(_contents,tocPath,false)
		logoUrl=parseBrand(logoUrl)
		indexUrl=parseBrand(indexUrl)
		tocUrl=parseBrand(tocUrl)
	}
	
	book.author.photo=calPath(_contents,book.author.photo,false)
	
	_theWins=_dyn?parent._theWins:new Array
	
	for (var i in _theWins) updateSubWin(i)
	if (_ie)
	{
		var titleWin=_dyn?parent:self
		titleWin.document.title="KeeBook - "+book.oldTitle
	}
}

function updateSubWin(i)
{
	if (i!="prefWin")
	{
		var theWin=_theWins[i]
		if ((i!="prldWin")&&(!theWin.closed))
		{
			if (theWin._subWinId)
			{
				var pg=book.getPageById(theWin._subWinId)
				
				if (pg)
				{
					theWin._page=(pg.page)-1
					var doc=_ns?theWin:theWin.document
					var nb=theWin.frames.length

					for (var i=0;i<nb;i++)
						doc.frames[i].location.replace(doc.frames[i].location.href)
					if (nb==0) theWin.document.location.replace(theWin.document.location)
				}
				else theWin.close()
			}
			else
				theWin.document.location.replace(theWin.document.location)
		}
	}
}

function changePageModeCB(side)
{
	var shiftPage=false
	with (_Book)
	{
		if (mode==2)
		{
			if (side!="left") page++
			else shiftPage=true
		}
		else page--

		if (page==-1) shiftPage=true
		page=Math.max(page,0)
		page=Math.min(page,book.pages.length-(mode==2?1:2))

		if (_ns||_macIE)
		{
			var loc=document.location.pathname
			if (_moz)
			{
				locSplit=loc.split("?")
				if (locSplit.length>0) loc=locSplit[0]
			}
			_closePopups=false
			document.location.replace(loc+"?mode="+(mode==2?1:2)+"&page="+page)
		}
		else
		{
			var theWin=(window==top) ? window.parent : self
			if (mode==2)
			{
				mode=1
				theWin.firstFrameSet.cols='20,0,55,*,20'
				if (shiftPage) changePage(page,true)
			}
			else
			{
				mode=2
				theWin.firstFrameSet.cols='20,*,55,*,20'
				if (shiftPage) changePage(page,true)
				else if ((_page["left"].url!=getPageURL(page))||(book.pages[_page["left"].idx].internal=="pict"))
				{
					getPageInfo()
					writeTitleAndPage('left',false)
				}
			}

			var rwr=getFrame('f_base_middle_right').reWrite
			if (rwr!=_NULL) rwr(_lab[(_Book.mode==1) ? 'switchTwoPage' : 'switchOnePage'])
		}
	}
}

function turnTabsCB(nb,right)
{
	right=(right==_NULL)?false:right
	with (_Book)
	{
		var newPage=0
		if (nb==-1) newPage=book.pages.length-mode
		else
		{
			newPage=book.tabs[nb]
			if ((right)&&(mode==2)) newPage=Math.max(0,newPage-1)
			if ((nb==0)&&(!right)&&(mode==2)) newPage=0
		}
		changePage(newPage)
	}
}

function Book()
{
	this.mode=2
	this.page=0

	this.init=Book_init
	this.write=Book_write
	this.changePage=Book_changePage
}

function showTab(pos,index,show)
{
	var frame=getFrame(pos=='left' ? 'f_lefttab_middle' : 'f_righttab_middle')
	if ((frame!=_NULL)&&(frame.showTab!=_NULL)) frame.showTab(index,show)
}

function currentChapterTab()
{
	var currentChapter=0
	var pageNum=(_Book.mode==2)?_Book.page:_Book.page-1

	for (var i=0; i<book.tabs.length; i++)
	{
		if (book.tabs[i] > pageNum) break
		else currentChapter++
	}
	return currentChapter
}

function updateTabs()
{
	var currentChapter=currentChapterTab()
	var tabsLen=Math.min(book.tabs.length,_MAX_CHAPTER)

	for (var i=0; i<tabsLen; i++)
	{
		var beforeChap=(i<currentChapter)
		showTab('left',i,beforeChap)
		showTab('right',i,!beforeChap)
	}
	
	var rightBi=_Book.page<book.pages.length-_Book.mode
	showTab('right',1000,rightBi)
	showTab('left',1000,!rightBi)
}

function goToWebViaImage(url)
{
	window.open(url+(_dyn?"":"&ReaderSKU="+ReaderSKU+"&ReaderPartner="+ReaderPartner+"&ReaderUser="+ReaderUser+"&ReaderAutorunCount="+ReaderAutorunCount))
}

function goTo7x(ClickSource,Redirect)
{
	url="http://"+(_dyn?"engine.keeboo.com/redirect/click.asp":"www.keeboo.com/redirect/click.asp")+"?ClickSource="
	window.open(url+ClickSource+"&WebBookID="+book.id+"&AuthorUser="+AuthorUser+"&ReaderSKU="+ReaderSKU+"&ReaderPartner="+ReaderPartner+"&AuthorSKU="+AuthorSKU+"&AuthorPartner="+AuthorPartner+"&ReaderUser="+ReaderUser+"&ReaderAutorunCount="+ReaderAutorunCount+"&Redirect="+Redirect+"&BookTitle="+escape(book.title))
}

function translateLink(linkURL)
{
	for (var i=0; i<book.pages.length; i++)
		if (linkURL==book.pages[i].url)
		{
			_Book.changePage(i,false)
			return
		}
	window.open(linkURL) 
}

function turnPagesFromTOC(nb)
{
	_Book.changePage(nb,false)
}

function getCookie(name)
{
	var cname=name+"="
	var dc=document.cookie
	if (dc.length > 0) 
	{
		var beg=dc.indexOf(cname)
		if (beg!=-1)
		{
			beg+=cname.length
			var end=dc.indexOf(";",beg)
			if (end==-1) end=dc.length
			return unescape(dc.substring(beg,end))
		}
	}
	return _NULL
}

function setCookie(name,value,nbDay) 
{
	var d=new Date()
	var expires=new Date(d.getTime()+nbDay * 24 * 60 * 60 * 1000)

	document.cookie=name+"="+escape(value)+"; path=/"+((expires==null) ? "" : "; expires="+expires.toGMTString())
}

function updateSurround(reset)
{
	if (reset)
	{
		changeFrameURL(getFrame("f_righttab_middle"),_common+"righttab_middle.htm")
		changeFrameURL(getFrame("f_lefttab_middle"),_common+"lefttab_middle.htm")
		changeFrameURL(getFrame("f_binder_middle"),_common+"binder_middle.htm")
	}
	
	else
	{
		if (getFrame('f_binder_middle').moveBinder) getFrame('f_binder_middle').moveBinder()
		updateTabs()
	}
}

function getTitle(item,old)
{
	with(_lab) switch(item.internal)
	{
		case "author": return authorPageTitle
		case "index": return index
		case "biblio": return _lab.biblio
		case "advert": return whatIs
		case "toc": return toc
	}
	return old?item.oldTitle:item.title
}

function getPageTitle(index,old)
{
	return getTitle(book.pages[index],old)
}

function getPageURL(index)
{
	switch(book.pages[index].internal)
	{
		case "author": return _localized+"authorlab.htm"
		case "index": return _common+"find_frameset.htm"
		case "pict": return _common+"photo.htm"
		case "advert": return _localized+"advertlab.htm"
		case "biblio": return _localized+"bibliolab.htm"
		case "chapter":
		case "toc": return _common+'sum_fram.htm'
	}
	var localFile=book.pages[index].fileName	
	if (localFile!="") return _contents+localFile
	else return book.pages[index].url
}

function historyLevel(side)
{
	var frame=getPageFrame(side,"content")
	if (frame==_NULL) return -1
	if (_ns) frame=getFrame('page',frame)
	if (frame==_NULL) return -1

	return frame.history.length
}

function checkExternalCB(side)
{
	with (_page[side]) if ((!_macIE)&&(light)) timer=setInterval("checkExternal('"+side+"')",500)
}

function checkExternal(side)
{
	if (historyLevel(side)>(_moz?2:(_ns||_macIE)?1:0))
	{
		clearInterval(_page[side].timer)
		_page[side].timer=_NULL
		_page[side].navigate=true
		
		var frame=getPageFrame(side,"top")
		if ((frame!=_NULL)&&(frame.reWrite!=_NULL))	frame.reWrite(side)
	}
}

function fillPageInfo(side,index)
{
	with(_page[side])
	{
		idx = index
		title=getPageTitle(index)
		url=getPageURL(index)
		external=!book.pages[index].isInDomain
		light=((book.pages[index].fileName=="")&&(book.pages[index].internal==_NULL))
		
		if (timer!=_NULL)
		{
			clearInterval(timer)
			timer=_NULL
		}
		
		if (light&&!_macIE) navigate=false
	}
}

function getPageInfo()
{
	with (_Book)
	{
		if (isNaN(page)) page=0
	
		if (mode==2)
		{
			fillPageInfo("left",page)
			fillPageInfo("right",page+1)
		}
		else fillPageInfo("right",page)
	}
}

function getPageFrame(side,frameType)
{
	return getFrame("f_"+side+(frameType=="top"?"page_top":"page"))
}

function getPageRealUrl(side,init,fromFind)
{
	with(_page[side])
	{
		if ((init&&(_ns||_macIE))||((fromFind)&&(side=="right"))) return _common+side+"page.htm"
		if (light) return _common+side+"_ext.htm"
		return url
	}
}

function writeTitleAndPage(side,fromFind)
{
	var frame=getPageFrame(side,"top")
	if ((frame!=_NULL)&&(frame.reWrite!=_NULL))	frame.reWrite(side)
	changeFrameURL(getPageFrame(side,"content"),getPageRealUrl(side,false,fromFind))
}

function Book_changePage(newPage,force,fromFind)
{
	with (this)
	{
		if ((newPage<0)||(newPage>=(book.pages.length-mode+1))) return

		force=(force==_NULL) ? false : force
		fromFind=(fromFind==_NULL) ? false : fromFind

		if ((newPage!=page)||force)
		{
			page=newPage
			getPageInfo()

			if (mode==2) writeTitleAndPage('left',fromFind)
			writeTitleAndPage('right',fromFind)
			updateSurround() 
		}
	}
}

function fset(rows,cols,onLoad,onUnload,name)
{
	return ("<FRAMESET "+attr("name",name)+attr("rows",rows)+attr("cols",cols)+attr("onload",onLoad)+attr("onunload",onUnload)+" frameborder=no border=0 framespacing=0>")
}

function startFrame(name,src,auto)
{
	if (auto==_NULL)auto=" scrolling='no'"
	else auto=''
	return ("<frame name='"+name+"'"+" src='"+src+"'"+auto+">")
}

function frm(name)
{
	return startFrame("f_"+name,_common+name+".htm")
}

function pg(url)
{
	var i=Math.max(url.lastIndexOf("/"),url.lastIndexOf("\\"))
	if (i>=0) url=url.slice(i+1)
	return url
}

function checkPage(side)
{
	var frm=getPageFrame(side)
	var real=getPageRealUrl(side,true,false)
	if (pg(real)!=pg(frm.document.location.href)) frm.document.location.replace(real)
}

function checkCB()
{
	checkPage("right")
	if (_Book.mode==2) checkPage("left")
}

function Book_write()
{
	if (_ie) if ((window.external!=_NULL)&&(window.external.provider!=_NULL)&&(window.external.provider.name=="KeeBoo"))
	{
		document.write(fset('*,0')+startFrame('f_import',_localized+'importlab.htm',"auto")+"</FRAMESET>")
		document.close()
		return
	}

	getPageInfo()
	var str=fset('*,22',_NULL,'if (_preload) preload();checkCB()','putInfoCB()')

	if (_ie) str+=fset(_NULL,(this.mode==1) ? '20,0,55,*,20' : '20,*,55,*,20',_NULL,_NULL,'firstFrameSet')
	else str+=fset(_NULL,(this.mode==1) ? '20,55,*,20' : '20,*,55,*,20',_NULL,_NULL,'firstFrameSet')

	str+=fset('*,30')+frm("lefttab_middle")+frm("lefttab_bottom")+"</FRAMESET>"
	if ((this.mode==2)||_ie) str+=fset('30,*')+frm("leftpage_top")+startFrame('f_leftpage',getPageRealUrl("left",true,false),'auto')+"</FRAMESET>"

	str+=fset('30,*,23')+frm("binder_top")+frm("binder_middle")+frm("binder_bottom")+"</FRAMESET>"
	str+=fset('30,*')+frm("rightpage_top")+startFrame('f_rightpage',getPageRealUrl("right",true,false),'auto')+"</FRAMESET>"
	str+=fset('*,55')+frm("righttab_middle")+frm("righttab_bottom")+"</FRAMESET></FRAMESET>"

	if (_dyn&&_partner) str+=fset(_NULL,'*,42')
	else str+=fset(_NULL,'220,*,220')+frm("base_middle_left")+frm("base_middle_right")+frm("base_right")+"</FRAMESET></FRAMESET>"

	str+=('<noframes><body><p>'+_lab.noFrames+'</p></body></noframes>')
	document.write(str)
	document.close()
}

function parseBrand(url)
{
	if (!_dyn&&(url.indexOf("WebBookID=")==-1)) return url+((url.indexOf("?")==-1) ? "?" : "&")+"WebBookID="+ WebBookID
	else return url
}

function mustOpenWin(w)
{
	if (_macIE) return true
	var ret=((w==_NULL)||((w!=_NULL)&&w.closed))
	if (!ret) w.focus()
	return ret
}

var _noDeco="statusbar=no,toolbar=no,menubar=no"
var winCnt=0

function openWin(url,name,prop)
{
	if (_macNS)
	{
		var theWin=window.open("",name,prop)
		theWin.document.location.replace(url)
		return theWin
	}
	else return window.open(url,name,prop)
}

function preload()
{
	if (mustOpenWin(_theWins["prldWin"]))
		_theWins["prldWin"]=openWin(_common+'preload_frameset.htm',"preload"+(winCnt++),_noDeco+",height=190,width=296,resizable=no")
}

function pref()
{
	if (mustOpenWin(_theWins["prefWin"]))
		_theWins["prefWin"]=openWin(_localized+'preflab.htm',"pref"+(winCnt++),_noDeco+",height="+(_ns?(_macNS?470:532):460)+",width=400,resizable=no")
}

function editWin()
{
	if (mustOpenWin(_theWins["editWin"]))
		_theWins["editWin"]=openWin(_common+'ed_fram.htm',"edit"+(winCnt++),"scrollbars,statusbar=no,toolbar=no,menubar=no,resizable"+getWinDim("right",false))
}

function getWinDim(side,isIndex)
{
	var dim=""
	var vfr=getFrame('f_binder_middle')
	if (vfr.windowHeight) dim+=",height="+vfr.windowHeight()
		
	var hfr=getPageFrame(side,"top")
	if (hfr.windowWidth)
	{
		var w=hfr.windowWidth()
		if(isIndex&&_Book.mode==1) w=Math.max(Math.round(w/2),420)
		dim+=",width="+w
	}
	return dim
}
		
var _thePrevId=0
function popWin(idx,side)
{
	var url=getPageURL(idx)
	var intl=book.pages[idx].internal
	var id=book.pages[idx].id
	
	if (intl)
	{
		var title="win"+id
		_thePrevId=id
		
		if (mustOpenWin(_theWins[title]))
		{
			if (intl=="pict")
				_theWins[title]=window.open(url+"?"+id)
			else
				_theWins[title]=openWin(url+"?"+id,title+(winCnt++),"scrollbars,statusbar=no,toolbar=no,menubar=no,resizable"+getWinDim(side,intl=="index"))
		}
	}
	else window.open(url)
}