/*
Copyright (c) 1997-2000,KeeBoo Corporation. All rights reserved.
Copyright application on progress at the Copyright Office.
This source code is the property of KeeBoo Corporation,
it cannot be reused,modified or published without prior 
written consent from KeeBoo Corporation.
KeeBoo and the KeeBoo logo are trademarks or registered
trademarks of KeeBoo Corporation.
*/

var _wrappers=new Array

function TreeListWrapper(chapter,parent,ext)
{
	this.chapter=chapter
	this.sub=new Array
	this.parent=parent
	this.expanded=_expand
	this.last=false
	this.x=0
	this.y=0
	if (parent==_NULL)
	{
		this.selection=new Array
		this.initialSelection=_NULL
		this.chapterId=chapter.id
		this.ext=ext
	}
	
	with (chapter)
	{
		for (var i=0; i<items.length; i++) if (items[i].isChapter)
			this.sub[this.sub.length]=new TreeListWrapper(items[i],this)

		var last=items.length-1
		if ((last>=0)&&(items[last].internal=="index")) last--
		
		if ((this.sub.length>0)&&(items[last].isChapter))
			this.sub[this.sub.length-1].last=true
	}
}

function getChapterByPage(page,chapter)
{
	var item=book.pages[page]
	if (item.internal=='toc') return book.chapter
	if (item.isChapter) return item
	return _NULL
}

function getWrapper(page,ext)
{
	if (page==_NULL) return _NULL
	var ch=getChapterByPage(page)
	if (ch==_NULL) return _NULL
	var id=(ext?"E":"W")+page
	if (_wrappers[id]==_NULL) _wrappers[id]=new TreeListWrapper(ch,_NULL,ext)
	return _wrappers[id]
}

function resetAllWrapper()
{
	_wrappers=new Array
}