/*
Copyright (c) 1997-2000,KeeBoo Corporation. All rights reserved.
Copyright application on progress at the Copyright Office.
This source code is the property of KeeBoo Corporation,
it cannot be reused,modified or published without prior 
written consent from KeeBoo Corporation.
KeeBoo and the KeeBoo logo are trademarks or registered
trademarks of KeeBoo Corporation.
*/

var _tipWidth=200

function heightLayer(id,frm)
{
	return _moz?0:(_ns?layerCSS(id,frm).clip.height:layerElem(id,frm).offsetHeight)
}

function getTooltipHTML(id)
{
	var str
	if (_ns&&!_moz) str="<layer id ='%1' visibility=%2 left=0 top=0 width=%3></layer>"
	else str="<div id='%1' style='visibility:%2;position:absolute;left:0;top:0;width:%3'></div>"
	
	return formatString(str,id,_hide,_tipWidth)
}

function showTooltip(id,str,x,y)
{
	reWriteLayer(str,id)
	
	if (_macIE||(_ie&&!_ie4))
	{
		x+=document.body.scrollLeft
		y+=document.body.scrollTop
	}

	y+=20
	x+=15

	if (!_moz)
	{
		var xRel=x-(_ns?self.pageXOffset:document.body.scrollLeft)
		var yRel=y-(_ns?self.pageYOffset:document.body.scrollTop)

		var newXrel=Math.max(0,Math.min(xRel,windowWidth() - _tipWidth))
		x=x+newXrel-xRel

		var height=heightLayer(id)
		if ((yRel+height)>windowHeight()) y=y-40-height
	}

	moveLayer(layerCSS(id),x,y)
	showLayer(true,id)
}

function hideTooltip(id)
{
	showLayer(false,id)
	moveLayer(layerCSS(id),0,0)
	if (_moz) reWriteLayer("",id)
}

function expColl(exp, wrap)
{
	with (wrap)
	{
		expanded=exp
		for (var i in sub) expColl(exp,sub[i])
	}
	if (wrap==_wrapper) updateTree()
}

function wrapperFromChapter(chapter,wrapper)
{
	if (wrapper==_NULL) return _NULL
	if (wrapper.chapter==chapter) return wrapper
		
	var returned=_NULL
	for (var i=0; i<wrapper.sub.length; i++)
	{
		returned=wrapperFromChapter(chapter,wrapper.sub[i])
		if (returned!=_NULL) return returned
	}
	
	return _NULL
}

function toggleChapter(index)
{
	var chapter=_ktop.getChapterByPage(index-1)
	if (chapter==_NULL) return
	var wrapper=wrapperFromChapter(chapter,_wrapper)
	if (wrapper==_NULL) return
	wrapper.expanded=!wrapper.expanded
	updateTree()
}

function updateTree()
{
	if (_moz||(_ie&&!_macIE))
	{
		reallyHide(0,true)
		_inhibitFirst=true
		reWriteLayer(getWrapperHtml(_wrapper),"toc")
	}
	else document.location.replace(document.location.href)
}

var _xMouse=0
var _yMouse=0
var _mousePage=-1
var _currentTipPage=-1
var _inhibitFirst=false

function tipText(page)
{
	return _ktop.book.pages[page].commentText
}

function reallyShow(page)
{
	if ((_currentTipPage!=page)&&(_mousePage==page))
	{
		_currentTipPage	=	page
		var htmlCode
		
		if (_ie||_moz) htmlCode="<div style='padding:2px;'class=toolTipBorder>%1</div>"
		else if (_ns) htmlCode="<table class=toolTipBorder border=0 cellpadding=0 cellspacing=0><tr><td><span class=toolTipBorder>%1</span></td></tr></table>"
		
		showTooltip("theTip",formatString(htmlCode,tipText(page)),_xMouse,_yMouse)
	}
}

function reallyHide(page,force)
{
	if ((_mousePage==-1)||force)
	{
		hideTooltip("theTip")
		_currentTipPage=-1
	}
}

function mouseOutCB(page)
{
	_mousePage=-1
	setTimeout("reallyHide("+page+",false)",200)
	return true
}

function mouseOverCB(obj,page)
{
	if ((tipText(page)!=_NULL)&&(!_inhibitFirst))
	{
		_mousePage=page
		setTimeout(formatString("reallyShow(%1)",page),800)
		return
	}
	_inhibitFirst=false
}

function tipEvent(page)
{
	return formatString(" onmouseover='mouseOverCB(this,%1)' onmouseout='mouseOutCB(%1)'",page-1)
}

function changePage(nb)
{
	var _mustShift=(parent.getPageSide()=="right")&&(_ktop._Book.mode==2)

	nb-=(_mustShift?2:1)
	
	if (parent.getPageSide()!="undefined")
	{
		var fr=_ktop.getFrame("f_lefttab_middle")
		if (fr&&fr._ktop) fr.focus()
	}
	_ktop.turnPagesFromTOC(nb)
}

function mouseMoveCB(ev)
{
	_xMouse=eventGetX(ev)
	_yMouse=eventGetY(ev)	
	return true	
}

function getWrapperHtml(currentWrapper)
{

	with (currentWrapper)
	{
		var lastItem=chapter.items.length-1
		if (lastItem>=0) if (chapter.items[lastItem].internal=="index") lastItem--
		
		var str=""
		
		if (parent==_NULL)
			str+='<table border=0 cellpadding=0 cellspacing=0 width=100%>'

		var before=""
		
		for (var par=currentWrapper; par.parent!=_NULL; par=par.parent)
			before=getImg(_neu+(par.last ? "menu_pixel.gif" : "menu_bar.gif"),18,18,"left")+before			

		if (_moz) before=getImg(_neu+"menu_pixel.gif",2,2,"left")+before
		
		var wrapIndex=0
		for (var i=0; i<=lastItem ; i++)
		{
			var item=chapter.items[i]
			var wrapper=item.isChapter ? sub[wrapIndex++] : _NULL
			var page=item.page

			if ((item.internal!='author')&&(item.internal!='toc')&&(item.internal!='index'))
			{
				str+='<tr valign=top><td>'+before
	
				if (wrapper!=_NULL)
				{
					if (_ns) str+="<a class=Normal href='javascript:toggleChapter("+page+")'"+tipEvent(page)+">"
					else str+="<span class=Normal style='cursor:hand' onclick='toggleChapter("+page+")'"+tipEvent(page)+">"
				}
			
				var img=_neu+"menu"
				img+=((i==lastItem)?"_corner":"_tee")
				if (wrapper!=_NULL) img+=(wrapper.expanded?"_minus":"_plus")
				img+=".gif"
				str+=getImg(img,18,18,"left")
			
				if (wrapper==_NULL) str+="<a class=Normal href='javascript:changePage("+page+")'"+tipEvent(page)+">"

				img=_neu+"menu"
				img+=(wrapper!=_NULL?(wrapper.expanded?"_folder_open.gif":"_folder_closed.gif"):"_link_local.gif")
			
				str+=getImg(img,16,16,"left")
				str+="&nbsp;"+_ktop.getTitle(item)+(item.enhanced ? "&nbsp;"+getImg(_neu+"qualif.gif",16,16,"top") : "")
				
				if ((wrapper!=_NULL)&&(_ie)) str+='</span>'
				else str+="</a>"
				str+='</td><td align=right '+(_ie||_moz?'class=Normal':'')+'>'
				if (_ns&&!_moz) str+='<span class=Normal>'
				str+=page
				if (_ns&&!_moz) str+='</span>'
				str+='</td></tr>'
			}

			if ((wrapper!=_NULL)&&(wrapper.expanded)) str+=getWrapperHtml(wrapper)
		}

		if (parent==_NULL) str+="</table>"
		return str
	}
}

function adjustScrollbars()
{
	if ((_wrapper.x!=0)||(_wrapper.y!=0))
	{
		if (_ns)
		{
			var tocCSS=layerCSS("toc")

			if (window.innerHeight<(tocCSS.clip.height+tocCSS.top))
				window.scrollTo(_wrapper.x,_wrapper.y)
		}
		else window.scrollTo(_wrapper.x,_wrapper.y)

		if (_ns) showLayer(true,"toc")
	}
}

function getScrollInfo()
{
	_wrapper.x=_ns?self.pageXOffset:document.body.scrollLeft
	_wrapper.y=_ns?self.pageYOffset:document.body.scrollTop
}

var _arr=new Array

function preloadImg(a)
{
	_arr=new Array(a.length)
	for (var i in a)
	{
		var im=new Image()
		_arr[_arr.length]=im
		im.src=_neu+a[i]
	}
}

function writeAll()
{
	if (_wrapper!=_NULL)
	{
		if (_ie&&!_macIE) preloadImg(new Array("menu_bar.gif","menu_corner.gif","menu_corner_minus.gif","menu_corner_plus.gif","menu_pixel.gif","menu_tee.gif","menu_tee_minus.gif","menu_tee_plus.gif","menu_folder_closed.gif","menu_folder_open.gif","menu_link_local.gif"))
		
		var hideDiv=(_wrapper.x!=0)||(_wrapper.y!=0)
		var onLoadUnload=_macIE ? "" : (attr("onunload","getScrollInfo()")+(_scrolled ? attr("onload","adjustScrollbars()") : ""))
		var beginDiv=(_ie||_moz) ? "<div id=toc>" : ("<layer id=toc "+(hideDiv ? "visibility='hidden'>" : ">"))
		var endDiv=(_ie||_moz) ? "</div>" : "</layer>"

		document.write("<HEAD><STYLE>"+"A{text-decoration:none;}"+_ktop._sty['body']+_ktop._sty2['.toolTipBorder']+_ktop._sty2['.toolTipText']+_ktop._sty['.Normal']+"</STYLE></HEAD><BODY "+onLoadUnload+">"+beginDiv+getWrapperHtml(_wrapper)+endDiv+getTooltipHTML("theTip")+"</BODY>")
		document.close()
		document.onmousemove=mouseMoveCB
		if (_ns) document.captureEvents(Event.MOUSEMOVE)
	}
}

var _wrapper=_ktop.getWrapper(parent._page,parent._ext)
var _scrolled=(_wrapper!=_NULL)?((_wrapper.x!=0)||(_wrapper.y!=0)):false